// bref.h
#include "common.h"

extern const uint16_t structprefsize;   // size of pref struct (for barometric reference pressure in different formats)

uint16_t goback;
//---------------------------------------------------------
// Declare the messages
const struct messages msg1 = {0x80, 13, "Set Reference"};
const struct messages msg2 = {0xC2, 9,  "Inches Hg"};
const struct messages msg3 = {0xC2, 10,  "Save?  N/Y"};
const struct messages msg4 = {0xC4, 7,  "Updated"};
const struct messages msg5 = {0x80, 15, "Ok, not changed"};
const struct messages msg6 = {0x80, 14, "Barometric Ref"};
const struct messages msg7 = {0x80, 13, "Local Offset:"};
const struct messages msg8 = {0x80, 13, "DST Observed:"};
const struct messages msg9 = {0xC4, 3, "Yes"};
const struct messages msg10 = {0xC4, 3, "No "};
const struct messages msg11 = {0x82, 10,  "Save?  N/Y"};
//================================================================
extern struct myswitch switch1;
extern struct myswitch switch2;
extern struct myswitch switch3;

extern void do_switch(unsigned char, struct myswitch *);
//=======================================
// State functions
void state0(void), state1(void), state2(void), state3(void), state4(void), state5(void),
     state6(void), state7(void), state8(void), state9(void);

// State array so they can be called by an index
void (*state_ptr[10])() = 
{ state0, state1, state2, state3, state4, state5, state6, state7, state8, state9 };
//=======================================
extern void SetCmdMode(void);
extern void SetChrMode(void);
extern void lcd_byte(char);
extern void domsg(const struct messages *);
extern void lcd_wr_instr(unsigned char);
extern void lcd_wr_data(unsigned char);
extern void clear_lcd(unsigned char);

extern uint16_t irq_flag, timer_flag, nflag;
extern uint16_t save_count, irq_count;

uint16_t state;
//======================================================
extern void LED_break(void);
void set_reference(void);

uint16_t ref_hg_bcd, ref_hg_bcd_save;
unsigned char ref_lcd[5];
uint32_t ref_mb_hex;
float ref_mb_float;
unsigned char ref_mb_lcd[6];

extern char nstr[256];
extern char line[256];
//======================================================
extern void uint8_bcd_str(unsigned char, char *);   // unsigned char to ASCII string, 3 digits  
extern void uint8_bcd_str2(unsigned char, char *);  // unsigned char to ASCII string, 2 digits
extern void sint8_bcd_str(int8_t, char *);          // signed char to ASCII string, 3 digits    
extern void uint16_bcd_str(uint16_t, char *);       // uint16 to ASCII string, 5 digits
extern void uint16_bcd_str4(uint16_t, char *);      // uint16 to ASCII string, 4 digits
extern void sint16_bcd_str(int16_t, char *);        // int16 to ASCII string, 5 digits
extern void uint32_bcd_str(uint32_t, char *);       // uint32_t to ASCII string, 8 digits
extern void sint32_bcd_str(int32_t, char *);        // int32_t to ASCII string, 8 digits
extern void uint8_hex_str(uint8_t, char *);         // unsigned char to ASCII string as hex digits, 2 digits    
extern void uint16_hex_str(uint16_t, char *);       // uint16 to ASCII string as 4 hex digits
extern void uint32_hex_str(unsigned long, char *);  // uint32 to ASCII string as 8 hex digits
//===================================================
void display_hg(uint16_t, uint16_t);
void inc_bref_bcd3(void);
void dec_bref_bcd3(void);
void inc_bref_bcd2(void);
void dec_bref_bcd2(void);
void inc_bref_bcd1(void);
void dec_bref_bcd1(void);
void inc_bref_bcd0(void);
void dec_bref_bcd0(void);
//=================================================
// For Saving the Barometric Reference Data
struct pref
{
    uint16_t pref_bcd;
    float pref_float; 
    uint32_t pref_int32;
    char pref_str[32];    // String, example: 29.92" Hg   1013.2 mb
};

struct pref pref_work;
void make_pref(uint16_t);  // hg_bcd
void show_pref(void);
extern void get_bref_flash(void);
extern void erase_bref_flash(void);
extern void do_B_reference(uint16_t);

extern uint16_t mode;   // 1 = bme-280; 0 = gps only
//=======================================
extern int16_t utc_offset;
unsigned char dst_observed;
uint16_t local_wr;

extern void myflash_erase_sector(uint16_t);
extern void erase_sector(uint16_t);
extern void do_local(int8_t, uint16_t, uint16_t);
extern void test_local(void);

extern struct alltime time;

extern void get_local_flash(void);
//---------------------------------------------
// For Saving the utc offset and dst enable
struct local
{
    int16_t offset;
    int16_t dst_enable; 
};

struct local mylocal;

extern void test_sint16(int16_t, int16_t);
//==========================================
