// Set Local Time
#include "common.h"

// Declare the messages
const struct messages lmsg1 =  {0x80, 16, "NEO7 GPS Clock "};
const struct messages lmsg2 =  {0xC0, 16, " Jed Margolin   "};
const struct messages lmsg3 =  {0x8B, 5,  "Local"};
const struct messages lmsg4 =  {0x8B, 6,  " UTC  "};
const struct messages lmsg5 =  {0x80, 10, "UTC Offset"};
const struct messages lmsg6 =  {0x80, 11, "Local 12/24"};
const struct messages lmsg7 =  {0x8D, 2,  "12"};
const struct messages lmsg8 =  {0x8D, 2,  "24"};
const struct messages lmsg9 =  {0x80, 3,  "DST"};
const struct messages lmsg10 = {0x84, 12,  "Observed    "};
const struct messages lmsg11 = {0x84, 12,  "Not Observed"};
const struct messages lmsg12 = {0x8C, 5,  "AM   "};
const struct messages lmsg13 = {0x8C, 5,  "PM   "};
const struct messages lmsg17 = {0x80, 12,  "DST Start 3/"};
const struct messages lmsg18 = {0xC0, 12,  "DST End  11/"};
const struct messages lmsg19 =  {0x80, 14, "# Sats in View"};
const struct messages lmsg20 =  {0x81, 14, "GPS Alarm Mode"};
const struct messages lmsg21 =  {0xCA, 5, " Good "};
const struct messages lmsg22 =  {0xCA, 5, "  Ok "};
const struct messages lmsg23 =  {0xCA, 5, "Oh Oh"};
const struct messages lmsg24 =  {0x84, 8, "Software"};
const struct messages lmsg25 =  {0xC2, 11, "Version 1.0"};
const struct messages lmsg26 =  {0x80, 15, "Waiting For PPS"};

extern void domsg(const struct messages *);

// Declare and initialize the switches
extern struct myswitch switch1;
extern struct myswitch switch2;
extern struct myswitch switch3;
extern struct myswitch switch4;

// Messages for the days of the week
extern const char day_array[7][3];

extern void SetChrMode(void);
extern void SetCmdMode(void);
extern void lcd_init(void);
extern void domsg(const struct messages *);
extern void lcd_wr_data(unsigned char);
extern void lcd_wr_instr(unsigned char);
extern void lcd_text(char *);
extern void lcd_byte(char);
extern void lcd_wr_hex(unsigned int, unsigned char);
extern void lcd_wr_hex16(unsigned int, unsigned int);
extern void convert_hex_bcd2(unsigned char, unsigned char *);
extern void lcd_wr_bcd(unsigned int, unsigned char);
extern void lcd_wr_bcd2(unsigned int, unsigned char);
extern void lcd_wr_time(unsigned int, unsigned int);
extern void lcd_wr_hex16(unsigned int, unsigned int);
extern void clear_lcd(unsigned char);
//========================================
extern uint16_t secs_flag, irq_flag, irq_count, save_count, gps_msg_number;
unsigned char linc_bcd(unsigned char, unsigned char, unsigned char);
unsigned char ldec_bcd(unsigned char, unsigned char, unsigned char);
extern const char month_array[18][3];

uint16_t blink, newsec2, oldsec2, wr_flash_flag;
int16_t save_year, hours12, dst_hour, my_second_flag;
extern int8_t utc_offset;
unsigned char dst_start_date, dst_end_date;
extern void decode_time(void);
extern void convert_utc_ascii(void);
extern void convert_utc_bin(void);

void start_local(void);
void get_local(void);
void get_local_plus(int16_t);
void get_local_minus(int16_t);
void test_local(void);

uint16_t ut_day, ut_month, ut_hour, ut_minute, ut_second, ut_year;
uint16_t pmflag, day, LastDay; 

// Days in the months - non-leap year
const signed char months[13] =
{ 0,    // unused
  31,   // January
  28,   // February
  31,   // March
  30,   // April
  31,   // May
  30,   // June
  31,   // July
  31,   // August
  30,   // September
  31,   // October
  30,   // November
  31    // December
};

// Days in the months - leap year
const signed char months_ly[13] =
{ 0,    // unused
  31,   // January
  29,   // February
  31,   // March
  30,   // April
  31,   // May
  30,   // June
  31,   // July
  31,   // August
  30,   // September
  31,   // October
  30,   // November
  31    // December
};

unsigned char is_dst(void);
uint16_t get_day(uint16_t, uint16_t, uint16_t);  // get the day of the week
extern uint16_t do_day_of_week(uint8_t, uint8_t, uint8_t);  // returns with string in nstr

unsigned char dst_window;    // 1 = we are in the dst window
unsigned char dst_start_date, dst_end_date;
extern unsigned char dst_observed;   // 1 = observe DST

void time12(void);

const unsigned int monthkey[12] = {1,4,4,0,2,5,0,3,6,1,4,6};  // month's key value
const unsigned char dst_start_table[7] = {9,8,14,13,12,11,10};
unsigned char dst_end_table[7] = {2,1,7,6,5,4,3};
void find_dst(uint16_t);
void display_local(void);
uint16_t is_leap(uint16_t);    // years in binary
uint16_t is_leap2(uint16_t);    // years in binary

// For Local Time
int16_t local_year, local_month, local_day, local_hour, local_minute, local_second;
unsigned char leapyear;

char loc_second[2], loc_minute[2], loc_hour[2], loc_day[2], loc_month[2], loc_year[4];
char *loc_sec_ptr = loc_second;

char *loc_min_ptr = loc_minute;
char *loc_hour_ptr = loc_hour;
char *loc_day_ptr = loc_day;
char *loc_month_ptr = loc_month;
char *loc_year_ptr = loc_year;

unsigned char loc_offset[4];
unsigned char *loc_offset_ptr = loc_offset;

extern void display_utc_lcd(void);
extern void display_utc_uart(void);

extern void uint8_bcd_str(unsigned char, char *);   // unsigned char to ASCII string, 3 digits  
extern void uint8_bcd_str2(unsigned char, char *);  // unsigned char to ASCII string, 2 digits
extern void sint8_bcd_str(int8_t, char *);          // signed char to ASCII string, 3 digits    
extern void uint16_bcd_str(uint16_t, char *);       // uint16 to ASCII string, 5 digits
extern void uint16_bcd_str4(uint16_t, char *);      // uint16 to ASCII string, 4 digits
extern void sint16_bcd_str(int16_t, char *);        // int16 to ASCII string, 5 digits
extern void uint32_bcd_str(uint32_t, char *);       // uint32_t to ASCII string, 8 digits
extern void sint32_bcd_str(int32_t, char *);        // int32_t to ASCII string, 8 digits
extern void uint8_hex_str(uint8_t, char *);         // unsigned char to ASCII string as 2 hex digits    
extern void uint16_hex_str(uint16_t, char *);       // uint16 to ASCII string as 4 hex digits
extern void uint32_hex_str(unsigned long, char *);  // uint32 to ASCII string as 8 hex digits

void convert_utc_bin(void);

extern char line[];
extern char nstr[];

//signed int ut_year, ut_month, ut_day, ut_hour, ut_minute, ut_second;
void convert_hex_bcd4(unsigned in, unsigned char *);
extern struct alltime time;
void test_sint16(int8_t, int16_t);

// For Saving the utc offset and dst enable
struct local
{
    int16_t utc_offset;
    int16_t dst_enable; 
};

extern struct local mylocal;
extern void LED_break(void);

// Lookup table for converting hex to ASCII, clock only needs to go up to 60 (because of leap seconds)
uint8_t clock8[122] = 
{
//     00          01          02          03           04         05          06          07          08          09          
0x30, 0x30, 0x30, 0x31, 0x30, 0x32, 0x30, 0x33, 0x30, 0x34, 0x30, 0x35, 0x30, 0x36, 0x30, 0x37, 0x30, 0x38, 0x30, 0x39,

//     10          11          12          13           14         15          16          17          18          19          
0x31, 0x30, 0x31, 0x31, 0x31, 0x32, 0x31, 0x33, 0x31, 0x34, 0x31, 0x35, 0x31, 0x36, 0x31, 0x37, 0x31, 0x38, 0x31, 0x39,

//     20          21          22          23           24         25          26          27          28          29          
0x32, 0x30, 0x32, 0x31, 0x32, 0x32, 0x32, 0x33, 0x32, 0x34, 0x32, 0x35, 0x32, 0x36, 0x32, 0x37, 0x32, 0x38, 0x32, 0x39,

//     30          31          32          33           34         35          36          37          38          39          
0x33, 0x30, 0x33, 0x31, 0x33, 0x32, 0x33, 0x33, 0x33, 0x34, 0x33, 0x35, 0x33, 0x36, 0x33, 0x37, 0x33, 0x38, 0x33, 0x39,

//     40          41          42          43           44         45          46          47          48          49          
0x34, 0x30, 0x34, 0x31, 0x34, 0x32, 0x34, 0x33, 0x34, 0x34, 0x34, 0x35, 0x34, 0x36, 0x34, 0x37, 0x34, 0x38, 0x34, 0x39,

//     50          51          52          53           54         55          56          57          58          59          
0x35, 0x30, 0x35, 0x31, 0x35, 0x32, 0x35, 0x33, 0x35, 0x34, 0x35, 0x35, 0x35, 0x36, 0x35, 0x37, 0x35, 0x38, 0x35, 0x39,

//     60
0x36, 0x30
};

void do_clock8(uint8_t);
void uint16_hex_bin_str(uint16_t, char *);
extern void decode_ZDA(uint16_t);
extern uint16_t zda_flag;

void test16(void);
void test1_clock8(void);
void test2_clock8(void);

