// myflash.h
#include "common.h"  // structures in common to other files (mine)
//=======================================================================
const uint16_t structprefsize = 44;   // size of pref struct (for barometric reference pressure in different formats)

extern struct myswitch switch1;
extern struct myswitch switch2;
extern struct myswitch switch3;

extern void do_switch(unsigned char, struct myswitch *); 
extern unsigned char timer_flag;

void do_flash(void);
extern void do_clock(void);
//---------------------------------------------
// LCD Messages
const struct messages tx_msg1 = {0x81, 14, "Jed Margolin's"};
const struct messages tx_msg2 = {0xC2, 10,  "Flash Demo"};
const struct messages tx_msg3 = {0x83, 8,  "(C) 2024"};
const struct messages tx_msg4 = {0x82, 9, "Reference"};
//======================================================
extern unsigned char nflag;
extern char nstr[];
extern char line[];
char start_date[22];

extern unsigned char uart_char;
extern unsigned char irq_flag, secs_flag, uart_flag;
extern unsigned int save_count, irq_count; 
extern unsigned char nflag;
uint16_t ts_number;

extern void LED_break(void);

void my_itoa(unsigned int, char *);
void my_itoa2(unsigned int, char *);
void line_fill_bin(unsigned char,char *, unsigned char, unsigned char);
void line_fill(unsigned char, char *, unsigned char, unsigned char);
void log_time(void);
void log2_time_uart(void);
//===============================================================
extern const uint16_t structlogsize;

void make_entry(void);
struct log flash_entry;   // make the log entry to be used in RAM and Flash
void show_log(struct log *ptr);
//================================================================
extern unsigned char time_buffer[];
extern const char month_array[18][3];
extern const char *month_name[12];
extern const char day_array[7][3];

extern void SetChrMode(void);
extern void SetCmdMode(void);
extern void lcd_init(void);
extern void domsg(const struct messages *);
extern void lcd_wr_data(unsigned char);
extern void lcd_wr_instr(unsigned char);
extern void lcd_text(char *);
extern void lcd_byte(char);
extern void lcd_wr_hex(unsigned int, unsigned char);
extern void convert_hex_bcd2(unsigned char, unsigned char *);
extern void lcd_wr_bcd(unsigned int, unsigned char);
extern void lcd_wr_bcd2(unsigned int, unsigned char);
extern void lcd_wr_bcd_A(unsigned int, unsigned char);
extern void lcd_wr_time(unsigned int, unsigned int);
extern void lcd_wr_hex16(unsigned int, unsigned int);
extern void lcd_wr_bcd4(unsigned int, unsigned int);
extern void clear_lcd(unsigned char);
//================================================================
// In common.h
/*
#define SECTOR_MAX 16  // sectors per block
#define FLASH_TARGET_OFFSET (512 * 1024)  // start of my flash data

#define FLASH_SDATE_SECTOR 258     // 256 sectors for my log, 16 sectors per page
#define FLASH_SDATE_PAGE 4128     

#define FLASH_BREF_SECTOR 259      // Barometric Reference. sector for erase
#define FLASH_BREF_PAGE 4144       // Barometric Reference, page for reading and writing

#define FLASH_LOCAL_SECTOR 260     // Local Time Offset, dst enable
#define FLASH_LOCAL_PAGE 4160      // Local Time Offset, dst enable

#define FLASH_DST_SECTOR 261       // DST dates
#define FLASH_DST_PAGE 4176        // DST dates

#define FLASH_TEST_SECTOR 262      // for testing
#define FLASH_TEST_PAGE 4192       // for testing
*/

void write_flash(unsigned char *, uint32_t);
void write_flash_sector(void);
void copy_ram_log_to_flash(struct log *ptr);
void erase_block(uint16_t);
void erase_all_blocks(void);
uint16_t is_sector_blank(uint32_t);
void read_flash_uart(uint32_t sector);
void read_sector(uint16_t sector, uint16_t number);
void log4_data_uart(struct log *);
void write_log(struct log *);
void erase_all_sectors(void);
void log1_time_uart(void);
void show_log2(struct log *);

extern uint16_t ref_hg_bcd;
void do_B_reference(uint16_t);
void do_local(int16_t, uint16_t, uint16_t);
void get_bref_flash(void);

void read_page(uint16_t, uint16_t);
void find_first_blank_page(void);  // Find the first blank Page_Index (and Bock_index)
void myflash_erase_sector(uint16_t);
void erase_sector(uint16_t);
uint16_t is_page_blank(uint32_t);    
void dump_flash(uint32_t, uint32_t);
void dump_flash_page_hex(uint32_t); 
void write_page(uint32_t, unsigned char *);

uint32_t ints;  // for interrupt
unsigned int Entry_Read_Index, Flash_Write_Index, erase_flag, reset_rx_start;
uint16_t Page_Index, Last_Page, Sector_Index;
extern unsigned char uart_flag_RX, uart_char;
uint16_t first_time_flash;
//uint32_t page_end;
void get_local_flash(void);
void test_read_sector(uint16_t);
void test_write_sector(uint16_t);
//================================================
void do_start_date(uint16_t);
void show_page(uint32_t);
void my_hextoa2(unsigned char, char *);
void dump_flash_page(uint32_t, uint16_t);  // with or without also dumping hex
void test10(void);
void copy_ram_log_to_flash(struct log *);
void log_flash_uart(uint32_t);
void show_log_ptr(struct log *);
void show_log_page(uint32_t);

void test_read_sector(uint16_t);
void myflash_erase_sector(uint16_t);
void erase_sector(uint16_t);
void erase_all_sectors(void);
void write_page(uint32_t, unsigned char *);

extern void temperature_itoa_str(int32_t, char *);      // remove leading zeros; end with NULL
extern void pressure_ltoa_str(uint32_t, char *);        // remove leading zeros; end with NULL
extern void humidity_btoa_str(uint8_t, char *);

extern unsigned char day_of_week;
//====================================================
// For Saving the Barometric Reference Data
struct pref
{
    uint16_t pref_bcd;
    float pref_float; 
    uint32_t pref_int32;
    char pref_str[32];    // String, example: 29.92" Hg   1013.2 mb
};

extern struct pref pref_work;
extern void make_pref(uint16_t);  // hg_bcd
extern void show_pref(void);

char utc_offset;
unsigned dst_flag;

// For Saving year, dst start, and dst end     length 44
struct dstdates
{
    unsigned char dst_start_month;  
    unsigned char dst_start_day;  
    unsigned char dst_end_month;  
    unsigned char dst_end_day;    
    unsigned char dst_year[8];      // string  
    unsigned char dst_start[16];    // string  
    unsigned char dst_end[16];      // string
};
struct dstdates dst_data;
const uint16_t structdstsize = 44; 

extern void uint16_hex_str(uint16_t, char *);       // unsigned int to hex string
void do_dst(uint16_t);
extern void decode_time(void);
extern unsigned char utc_year[4];
extern void uint16_bcd_str(uint16_t, char *);   // unsigned uint16 to BCD string 
uint16_t year_hex_full;
extern unsigned char gps_time_buffer[128];

extern void test20(void);
extern unsigned char utc_hour[2], utc_min[2], utc_sec[2], utc_day[2], utc_month[2], utc_year[4];
extern unsigned char *utc_hour_ptr, *utc_min_ptr, *utc_sec_ptr, *utc_day_ptr, *utc_mon_ptr, *utc_year_ptr;
extern uint8_t month_hex, date_hex, year_hex;
void do_day_of_week(uint8_t, uint8_t, uint8_t);
extern uint8_t month_hex, date_hex, year_hex;
extern unsigned char day_of_week;
extern unsigned char is_leap2(uint16_t year);    // years in binary
extern unsigned char leapyear;
extern unsigned char dst_observed;   // 1 = observe DST
extern void get_local_plus(signed char);
extern void get_local_minus(signed char);
extern unsigned char is_dst(void);
extern uint16_t local_year, local_month, local_day, local_hour, local_minute, local_second;

extern struct alltime time;

void todays_date(uint16_t);

extern void uint8_bcd_str(unsigned char, char *);   // unsigned char to ASCII string, 3 digits  
extern void uint8_bcd_str2(unsigned char, char *);  // unsigned char to ASCII string, 2 digits
extern void sint8_bcd_str(int8_t, char *);          // signed char to ASCII string, 3 digits    
extern void uint16_bcd_str(uint16_t, char *);       // uint16 to ASCII string, 5 digits
extern void uint16_bcd_str4(uint16_t, char *);      // uint16 to ASCII string, 4 digits
extern void sint16_bcd_str(int16_t, char *);        // int16 to ASCII string, 5 digits
extern void uint32_bcd_str(uint32_t, char *);       // uint32_t to ASCII string, 8 digits
extern void sint32_bcd_str(int32_t, char *);        // int32_t to ASCII string, 8 digits
extern void uint8_hex_str(uint8_t, char *);         // unsigned char to ASCII string as hex digits, 2 digits    
extern void uint16_hex_str(uint16_t, char *);       // uint16 to ASCII string as 4 hex digits
extern void uint32_hex_str(unsigned long, char *);  // uint32 to ASCII string as 8 hex digits

// For Saving the utc offset and dst enable
struct local
{
    int16_t utc_offset;
    int16_t dst_enable; 
};

extern struct local mylocal;
extern void test_sint16(int16_t, int16_t);
//==========================================
